// jpnslisp.h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <alloc.h>

#define LINE_BUF_SIZE 256
#define BUFLEN 20000
#define FALSE 0
#define TRUE 1
#define CELL_SIZE 32000000L
#define STRING_SIZE 320000L
#define STRING_NUM 100000L
#define NUMBER_SIZE 3200000L
#define INT_SIZE 3200000L
#define GLOBAL_SIZE 3200L
#define FUNCTION_SIZE 3200L
#define READ_EVAL_NUM 39
//#define MOJIRETSU_SIZE 320000L
#define FILE_POINTER_LEN 10
#define PATH_LEN 256

#define CELL_STACK_SIZE 32000000L
//#define NUMBER_STACK_SIZE 3200000L
#define LOC_STACK_SIZE 3200000L
#define STATIC_STACK_SIZE 32000L

#define CELL_SIZE_MIN 1000L
#define NUMBER_SIZE_MIN 1000L
#define INT_SIZE_MIN 1000L
//#define MOJIRETSU_SIZE_MIN 1024L

typedef int BOOL;

struct _afloat {
	char gc;
	long double f;
};

typedef struct _afloat AFLOAT;

struct _aint {
	char gc;
	long f;
};

typedef struct _aint AINT;

struct _cell {
	char attr;  // n:_Ai:As:V{Al:XgiRXZjAb:Am:Ar:Aa:z
        char attr2; // u:ʏAc:RŎn܂V{
	char gc;
//        char returnflag; // ʏu
	struct _cell *car;
	struct _cell *cdr;
        struct _cell *mtop;  // lp@ʏNULL
	struct _symval *clj;
	long cljlen;
};

typedef struct _cell CELL;

struct _symval {
	char attr;
	CELL *sym;  // attrs̃Z
	CELL *val;
};

typedef struct _symval SYMVAL;

void printS(CELL *);
void printS2(CELL *,BOOL);
void printS3(CELL *);
void princS(CELL *,FILE *);
void princS2(CELL *,BOOL,FILE *);
void princS3(CELL *,FILE *);
void printSStrm(CELL *,FILE *);
void printS2Strm(CELL *,BOOL,FILE *);
void printS3Strm(CELL *,FILE *);
CELL *eval(CELL *,SYMVAL *,long);

CELL *getCell(void);
CELL *SetArray(CELL *,SYMVAL *,long);
//CELL *aref(CELL *,SYMVAL *,long);
//CELL *prearef(CELL *,SYMVAL *,long);
CELL *ArrayCar(CELL *);
CELL *ArrayCdr(CELL *);

CELL *getMojiretsuCell(char *);
CELL *getMojiCell(char c1,   // A܂̓VtgihrR[hPoCg
		  char c2 ); // VtgihrR[hQoCg
int isKanji(unsigned char *);
AINT *getInt(long);
CELL *topen(CELL *,SYMVAL *,long);
CELL *SetFilePointer(FILE *);
void PutString(CELL *,FILE *);  // a = (#\h #\e #\l #\l #\o) etc.
void PutStringC(CELL *,FILE *);  // a = (#\h #\e #\l #\l #\o) etc.
CELL *ReadLine(void);
void slide(char *,int);
CELL *StringEqual(CELL *,CELL *);
CELL *coerce(CELL *,SYMVAL *,long);
CELL *Copy(CELL *);
CELL *tchar(CELL *,SYMVAL *,long);
